int richtungA = 12;  // Richtung Motor A
int richtungB = 13;  // Richtung Motor B
int pwmA      =  3;  // Geschwindigkeit Motor A
int pwmB      = 11;  // Geschwindigkeit Motor B
int bremseA   =  9;  // Bremse Motor A
int bremseB   =  8;  // Bremse Motor B


// Geschwindigkeit der Motoren.
// 255 ist der Maximalwert!
int geschwindigkeitA = 128; // rechter Motor
int geschwindigkeitB = 127; // linker  Motor


void setup()
{
  // Pins für Motorenrichtungen als Ausgang
  pinMode(richtungA, OUTPUT);
  pinMode(richtungB, OUTPUT);
  
  // Pins für Bremsen als Ausgang
  pinMode(bremseA, OUTPUT);
  pinMode(bremseB, OUTPUT);

  // Geschwindigkeiten setzen
  analogWrite(pwmA, geschwindigkeitA);
  analogWrite(pwmB, geschwindigkeitB);
  
  // "Bremse anziehen" (Motoren aus)
  // Man weiß ja nie...
  bremsen(true);

  // 2 Sekunden stehen. Zur Sicherheit...
  delay(2000);
}


void loop()
{
  // 2 Sekunden geradeaus fahren
  geradeaus(2000);

  // kurz warten...
  delay(1000);

  // links herum drehen
  drehen(false);

  // kurz warten...
  delay(1000);

  // 2 Sekunden geradeaus fahren
  geradeaus(2000);

  // kurz warten...
  delay(1000);

  // rechts herum drehen
  drehen(true);

  // kurz warten...
  delay(1000);
}


// Lässt den Roboter geradeaus fahren
// 'dauer' ist die Fahrtdauer in ms.
// Bremst am Ende der Fahrt automatisch.
void geradeaus(int dauer)
{
  // Geradeaus
  digitalWrite(richtungA, HIGH);
  digitalWrite(richtungB, HIGH);

  // "Bremsen lösen"
  bremsen(false);

  // 'dauer' Sekunde fahren...
  delay(dauer);

  // "Bremsen"
  bremsen(true);
}


// Lässt den Roboter drehen.
// false = links herum
// true  = rechts herum
void drehen(boolean richtung)
{
  // Dauer in ms, die der Roboter sich dreht.
  // Bei genau abgestimmter Zeit erreicht man ca. 90°
  int drehdauer = 600;
  
  
  if (richtung == false)
  {
    // "links herum" drehen
    digitalWrite(richtungA, HIGH);
    digitalWrite(richtungB, LOW);
  }
  else
  {
    // "rechts herum" drehen
    digitalWrite(richtungA, LOW);
    digitalWrite(richtungB, HIGH);
  }

  // "Bremsen lösen". Los geht's!
  digitalWrite(bremseA, LOW);
  digitalWrite(bremseB, LOW);

  // drehen...
  delay(drehdauer);

  // "Bremsen anziehen" (Motoren aus)
  digitalWrite(bremseA, HIGH);
  digitalWrite(bremseB, HIGH);
}


// Lässt die Bremse anziehen oder lösen.
// true  = Bremse angezogen
// false = Bremse gelöst
void bremsen(boolean aktiviert)
{
  if (aktiviert == true)
  {
    // "Bremsen anziehen" (Motoren aus)
    digitalWrite(bremseA, HIGH);
    digitalWrite(bremseB, HIGH);
  }
  else
  {
    // "Bremsen lösen". Los geht's!
    digitalWrite(bremseA, LOW);
    digitalWrite(bremseB, LOW);
  }
}

