int richtungA = 12;  // Richtung Motor A
int richtungB = 13;  // Richtung Motor B
int pwmA      =  3;  // Geschwindigkeit Motor A
int pwmB      = 11;  // Geschwindigkeit Motor B
int bremseA   =  9;  // Bremse Motor A
int bremseB   =  8;  // Bremse Motor B


// Geschwindigkeit der Motoren.
// 255 ist der Maximalwert!
int geschwindigkeitA = 148; // rechter Motor
int geschwindigkeitB = 147; // linker  Motor

// Zielgeschwindigkeit linker Motor
int endGeschwindigkeitB = 40;

void setup()
{
  // Pins für Motorenrichtungen als Ausgang
  pinMode(richtungA, OUTPUT);
  pinMode(richtungB, OUTPUT);
  
  // Pins für Bremsen als Ausgang
  pinMode(bremseA, OUTPUT);
  pinMode(bremseB, OUTPUT);

  // Geschwindigkeiten setzen
  analogWrite(pwmA, geschwindigkeitA);
  analogWrite(pwmB, geschwindigkeitB);
  
  // "Bremse anziehen" (Motoren aus)
  // Man weiß ja nie...
  bremsen(true);

  // 2 Sekunden stehen. Zur Sicherheit...
  delay(2000);

  // fahre vorwärts
  digitalWrite(richtungA, HIGH);
  digitalWrite(richtungB, HIGH);

  // "Bremsen lösen"
  bremsen(false);
}


void loop()
{
  // 
  if (geschwindigkeitB > endGeschwindigkeitB)
  {
    // Geschwindigkeit Motor B um 1 verringern
    geschwindigkeitB--;

    // Geschwindigkeiten setzen
    analogWrite(pwmB, geschwindigkeitB);

    // warte ein klein wenig, damit die Fahrtrichtung kurz beibehalten wird
    delay(150);
  }
}


// Lässt die Bremse anziehen oder lösen.
// true  = Bremse angezogen
// false = Bremse gelöst
void bremsen(boolean aktiviert)
{
  if (aktiviert == true)
  {
    // "Bremsen anziehen" (Motoren aus)
    digitalWrite(bremseA, HIGH);
    digitalWrite(bremseB, HIGH);
  }
  else
  {
    // "Bremsen lösen". Los geht's!
    digitalWrite(bremseA, LOW);
    digitalWrite(bremseB, LOW);
  }
}

