int ledPin = 13; // Der übliche LED-Pin
int IRpin  = A0; // Der Pin für den Infrarotsensorausgang


void setup()
{
  pinMode(ledPin, OUTPUT);  // LED-Pin als Ausgang definieren
  pinMode(IRpin, INPUT);    // IR-Pin als Eingang definieren
}


void loop()
{
  // Sensor (Pin) einlesen
  float spannungswert = analogRead(IRpin);
  
  // Umrechnen in cm
  float entfernung = (6787 / (spannungswert - 3)) - 4;

  // delay-Wert begrenzen
  if (entfernung > 80)
    entfernung = 80;
    
  if (entfernung < 10)
    entfernung = 10;

  // Entfernung für delay umrechnen
  int zeit = 0;
  zeit = map(entfernung, 10, 80, 100, 1000);

  // LED blinkt
  digitalWrite(ledPin, HIGH);
  delay(zeit);
  digitalWrite(ledPin, LOW);
  delay(zeit);
}

