// An Pin 5 ist nun eine LED mit Widerstand angeschlossen.
int ledPin = 5;

// Pin A0 für den Infrarotsensorausgang
int IRpin  = A0;


void setup()
{
  pinMode(ledPin, OUTPUT);  // LED-Pin als Ausgang definieren
  pinMode(IRpin, INPUT);    // IR-Pin als Eingang definieren
}


void loop()
{
  // Sensor (Pin) einlesen
  float spannungswert = analogRead(IRpin);
  
  // Umrechnen in cm
  float entfernung = (6787 / (spannungswert - 3)) - 4;

  // delay-Wert begrenzen
  if (entfernung > 80)
    entfernung = 80;
    
  if (entfernung < 10)
    entfernung = 10;

  // Entfernung in Helligkeitswert (PWM) umrechnen
  // 10-80cm > 255-0 Wert
  // Je geringer der Abstand, desto heller die LED.
  int helligkeit = 0;
  helligkeit = map(entfernung, 10, 80, 255, 0);

  // LED ändert die Helligkeit durch PWM
  analogWrite(ledPin, helligkeit);
}

