// Bibliotheken für das LCD einbinden
#include <Wire.h> // I2C
#include <Adafruit_MCP23017.h>
#include <Adafruit_RGBLCDShield.h>

// Ein lcd Objekt zur Ansteuerung erstellen
Adafruit_RGBLCDShield lcd = Adafruit_RGBLCDShield();

// Diese #defines machen es einfach, die Farben
// für die Hintergrundbeleuchtung im Code zu verwenden.
#define RED     0x1
#define YELLOW  0x3
#define GREEN   0x2
#define TEAL    0x6
#define BLUE    0x4
#define VIOLET  0x5
#define WHITE   0x7

void setup()
{
  // Das LCD ist 16 Zeichen breit und hat 2 Zeilen
  lcd.begin(16, 2);

  // Hintergrundfarbe auf weiß setzen
  lcd.setBacklight(WHITE);

  // Text ausgeben
  // Die Zahlen im Kommentar dienen nur zur Oritentierung.
  //         1234567890123456
  lcd.print(" Roboter  bauen ");

  // Cursor zu Spalte 0 und Zeile 1 bewegen.
  // Achtung: Zeile 1 ist die zweite. Zeile 0 ist die erste!
  lcd.setCursor(0, 1);

  //         1234567890123456
  lcd.print("  mit  Arduino  ");
}


void loop()
{
  // Jetzt die Tasten des LCD auslesen
  byte buttons = lcd.readButtons();


  if (buttons != 0)
  {
    // Text komplett löschen
    lcd.clear();
    
    // Cursor auf 0,0 setzen
    lcd.setCursor(0,0);
    lcd.print("Gedrueckte Taste");

    if (buttons == BUTTON_UP)
    {
      // Text ausgeben
      lcd.setCursor(0,1);
      lcd.print("Hoch   ");

      // Hintergrundbeleuchtung/farbe ändern
      lcd.setBacklight(RED);
    }
    
    if (buttons == BUTTON_DOWN)
    {
      // Text ausgeben
      lcd.setCursor(0,1);
      lcd.print("Runter ");

      // Hintergrundbeleuchtung/farbe ändern
      lcd.setBacklight(YELLOW);
    }
    
    if (buttons == BUTTON_LEFT)
    {
      // Text ausgeben
      lcd.setCursor(0,1);
      lcd.print("Links  ");

      // Hintergrundbeleuchtung/farbe ändern
      lcd.setBacklight(GREEN);
    }
    
    if (buttons == BUTTON_RIGHT)
    {
      // Text ausgeben
      lcd.setCursor(0,1);
      lcd.print("Rechts ");

      // Hintergrundbeleuchtung/farbe ändern
      lcd.setBacklight(TEAL);
    }
    
    if (buttons == BUTTON_SELECT)
    {
      // Text ausgeben
      lcd.setCursor(0,1);
      lcd.print("Auswahl");

      // Hintergrundbeleuchtung/farbe ändern
      lcd.setBacklight(VIOLET);
    }
  }
}

