int ledPin = 13; // Der übliche LED-Pin
int IRpin  = A0; // Der Pin für den Infrarotsensor
int piezo  =  5; // An Pin 5 ist der Piezo angeschlossen.


void setup()
{
  pinMode(ledPin, OUTPUT);  // LED-Pin als Ausgang definieren
  pinMode(IRpin, INPUT);    // IR-Pin als Eingang definieren
  pinMode(piezo, OUTPUT);   // Piezo-Pin als Ausgang definieren
}


void loop()
{
  // Sensor (Pin) einlesen
  float spannungswert = analogRead(IRpin);
  
  // Umrechnen in cm
  float entfernung = (6787 / (spannungswert - 3)) - 4;

  // Den delay-Wert begrenzen
  if (entfernung > 80)
    entfernung = 80;
    
  if (entfernung < 10)
    entfernung = 10;

  // Entfernung auf Pause zwischen den Tönen mappen
  // 5-100 ms Pause bei 10-80cm Entfernung
  int pause = 0;
  pause = map(entfernung, 10, 80, 5, 100);

  // LED an
  digitalWrite(ledPin, HIGH);

  // Spiele Ton mit 1000 Hz für 100 ms ab.
  playTone(1000, 100);

  // LED aus
  digitalWrite(ledPin, LOW);

  // Pause zwischen den Tönen, gemäß Variable
  delay(pause);
}


// Frequenz in Hertz (Hz)
// Dauer in Millisekunden (ms)
void playTone(int frequenz, long dauer)
{
  dauer *= 1000;
  float periode = (1.0 / frequenz) * 1000000;
  long laufzeit = 0;

  while (laufzeit < dauer)
  {
    digitalWrite(piezo,HIGH);
    delayMicroseconds(periode * 0.5);

    digitalWrite(piezo, LOW);
    delayMicroseconds(periode * 0.5);

    laufzeit += periode;
  }
}

