// An Pin 5 ist der Piezo angeschlossen.
int piezo =  5;
// Die on-board LED.
int led = 13;


void setup()
{
  // Die Pins zur Ausgabe festlegen.
  pinMode(piezo, OUTPUT);     
  pinMode(led, OUTPUT);     
}


void loop()
{
  // LED zur Kontrolle einschalten.
  digitalWrite(led, HIGH);

  // Ton mit 1000 Hz für 200 ms spielen.
  playTone(1000, 200);

  // LED ausschalten.
  digitalWrite(led, LOW);

  // Eine Sekunde warten.
  delay(1000);
}


// Frequenz in Hertz (Hz)
// Dauer in Millisekunden (ms)
void playTone(float frequenz, long dauer)
{
  // Dauer umrechnen in Sekunden
  dauer *= 1000;
  
  // Umrechnen von Frequenz in Periodendauer
  // siehe http://www.elektrotechnik-fachwissen.de/wechselstrom/periodendauer-frequenz.php
  float periode = (1.0 / frequenz) * 1000000;
  long laufzeit = 0;


  while (laufzeit < dauer)
  {
    digitalWrite(piezo,HIGH);
    delayMicroseconds(periode * 0.5);

    digitalWrite(piezo, LOW);
    delayMicroseconds(periode * 0.5);

    laufzeit += periode;
  }
}

