int IRpin  =  A2; // Der Pin für den Infrarotsensorausgang

int richtungA        = 12;  // Pin für Richtung Motor A
int geschwindigkeitA =  3;  // Pin für Geschwindigkeit Motor A
int bremseA          =  9;  // Pin für Bremse Motor A


void setup()
{
  // IR-Sensor-Pin als Eingang definieren
  pinMode(IRpin, INPUT);

  // Motor A initialisieren
  // Pin für Richtung Motor A als Ausgang
  pinMode(richtungA, OUTPUT);
  
  // Pin für Bremse Motor A als Ausgang
  pinMode(bremseA, OUTPUT);
  
  // "Bremse anziehen" (Motor aus)
  // Man weiß ja nie...
  digitalWrite(bremseA, HIGH);
}


void loop()
{
  // Sensor (Pin) einlesen
  int sensorwert = analogRead(IRpin);

  // Wenn Entfernung sehr hoch (Wert klein): Motor AUS
  // (98 ist sehr weit weg)
  if (sensorwert < 98)
  {
    // "Bremsen". Motor stoppen.
    digitalWrite(bremseA, HIGH);
  }
  else
  {
    // Ansonsten Motorgeschwindigket gemäß Entfernung
    
    // Entfernung für Motorgeschwindigkeit umrechnen
    // (Sensor liefert Werte von 630 - 90)
    int drehzahl = map(sensorwert, 630, 0, 255, 0);
  
    // Motor drehen!
    motorDrehen(HIGH, drehzahl);
  }
}


void motorDrehen(int richtung, int geschwindigkeit)
{
  // Motorrichtung einstellen
  digitalWrite(richtungA, richtung);

  // Geschwindigkeit je nach Argument
  analogWrite(geschwindigkeitA, geschwindigkeit);

  // "Bremse lösen". Los geht's!
  digitalWrite(bremseA, LOW);
}

