#include <Bounce2.h>


#define TASTER_PIN  2 // Pin für den Taster (gegen GND)
#define LED_PIN    13 // Die übliche Arduino-LED


// Erstelle ein Bounce Objekt welches das Entprellen regelt.
Bounce entpreller = Bounce(); 

void setup()
{
  // Taster-Pin als Eingang definieren
  pinMode(TASTER_PIN, INPUT);
  
  // Internen pull-up-Widerstand aktivieren
  pinMode(TASTER_PIN, INPUT_PULLUP);     
  
  // Entprellfunktion aktivieren
  entpreller.attach(TASTER_PIN);
  entpreller.interval(5);
  
  // LED-Pin als Ausgang definieren
  pinMode(LED_PIN,OUTPUT); 
}


void loop()
{
  // Entpreller (entpreller) aktualisieren
  entpreller.update();
 
  // "Korrigierten" Wert des Tasters lesen
  int wert = entpreller.read();
 
  // LED ein- oder ausschalten
  // (LOW = EIN, weil pull-up-Widerstand!)
  if (wert == LOW)
  {
    // LED an
    digitalWrite(LED_PIN, HIGH);
  }
  else
  {
    // LED aus
    digitalWrite(LED_PIN, LOW);
  }
}

